/*
 * generated by Xtext 2.13.0
 */
package com.javadude.dsl5.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractGrammarElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class GothicSecurityDslGrammarAccess extends AbstractGrammarElementFinder {
	
	public class StateMachineElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.javadude.dsl5.GothicSecurityDsl.StateMachine");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cStateMachineKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Keyword cStartKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cStartStateAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final CrossReference cStartStateStateCrossReference_4_0 = (CrossReference)cStartStateAssignment_4.eContents().get(0);
		private final RuleCall cStartStateStateIDTerminalRuleCall_4_0_1 = (RuleCall)cStartStateStateCrossReference_4_0.eContents().get(1);
		private final Assignment cCommandsAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cCommandsCommandParserRuleCall_5_0 = (RuleCall)cCommandsAssignment_5.eContents().get(0);
		private final Assignment cEventsAssignment_6 = (Assignment)cGroup.eContents().get(6);
		private final RuleCall cEventsEventParserRuleCall_6_0 = (RuleCall)cEventsAssignment_6.eContents().get(0);
		private final Assignment cStatesAssignment_7 = (Assignment)cGroup.eContents().get(7);
		private final RuleCall cStatesStateParserRuleCall_7_0 = (RuleCall)cStatesAssignment_7.eContents().get(0);
		private final Assignment cResetEventsAssignment_8 = (Assignment)cGroup.eContents().get(8);
		private final RuleCall cResetEventsResetParserRuleCall_8_0 = (RuleCall)cResetEventsAssignment_8.eContents().get(0);
		private final Assignment cTestsAssignment_9 = (Assignment)cGroup.eContents().get(9);
		private final RuleCall cTestsTestParserRuleCall_9_0 = (RuleCall)cTestsAssignment_9.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_10 = (Keyword)cGroup.eContents().get(10);
		
		//StateMachine:
		//	'stateMachine' name=ID '{'
		//	'start' startState=[State] commands+=Command*
		//	events+=Event*
		//	states+=State*
		//	resetEvents+=Reset*
		//	tests+=Test*
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'stateMachine' name=ID '{' 'start' startState=[State] commands+=Command* events+=Event* states+=State*
		//resetEvents+=Reset* tests+=Test* '}'
		public Group getGroup() { return cGroup; }
		
		//'stateMachine'
		public Keyword getStateMachineKeyword_0() { return cStateMachineKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//'start'
		public Keyword getStartKeyword_3() { return cStartKeyword_3; }
		
		//startState=[State]
		public Assignment getStartStateAssignment_4() { return cStartStateAssignment_4; }
		
		//[State]
		public CrossReference getStartStateStateCrossReference_4_0() { return cStartStateStateCrossReference_4_0; }
		
		//ID
		public RuleCall getStartStateStateIDTerminalRuleCall_4_0_1() { return cStartStateStateIDTerminalRuleCall_4_0_1; }
		
		//commands+=Command*
		public Assignment getCommandsAssignment_5() { return cCommandsAssignment_5; }
		
		//Command
		public RuleCall getCommandsCommandParserRuleCall_5_0() { return cCommandsCommandParserRuleCall_5_0; }
		
		//events+=Event*
		public Assignment getEventsAssignment_6() { return cEventsAssignment_6; }
		
		//Event
		public RuleCall getEventsEventParserRuleCall_6_0() { return cEventsEventParserRuleCall_6_0; }
		
		//states+=State*
		public Assignment getStatesAssignment_7() { return cStatesAssignment_7; }
		
		//State
		public RuleCall getStatesStateParserRuleCall_7_0() { return cStatesStateParserRuleCall_7_0; }
		
		//resetEvents+=Reset*
		public Assignment getResetEventsAssignment_8() { return cResetEventsAssignment_8; }
		
		//Reset
		public RuleCall getResetEventsResetParserRuleCall_8_0() { return cResetEventsResetParserRuleCall_8_0; }
		
		//tests+=Test*
		public Assignment getTestsAssignment_9() { return cTestsAssignment_9; }
		
		//Test
		public RuleCall getTestsTestParserRuleCall_9_0() { return cTestsTestParserRuleCall_9_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_10() { return cRightCurlyBracketKeyword_10; }
	}
	public class CommandElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.javadude.dsl5.GothicSecurityDsl.Command");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cCommandKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cCodeKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cCodeAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cCodeIDTerminalRuleCall_3_0 = (RuleCall)cCodeAssignment_3.eContents().get(0);
		
		//Command:
		//	'command' name=ID 'code' code=ID;
		@Override public ParserRule getRule() { return rule; }
		
		//'command' name=ID 'code' code=ID
		public Group getGroup() { return cGroup; }
		
		//'command'
		public Keyword getCommandKeyword_0() { return cCommandKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//'code'
		public Keyword getCodeKeyword_2() { return cCodeKeyword_2; }
		
		//code=ID
		public Assignment getCodeAssignment_3() { return cCodeAssignment_3; }
		
		//ID
		public RuleCall getCodeIDTerminalRuleCall_3_0() { return cCodeIDTerminalRuleCall_3_0; }
	}
	public class EventElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.javadude.dsl5.GothicSecurityDsl.Event");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cEventKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cCodeKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cCodeAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cCodeIDTerminalRuleCall_3_0 = (RuleCall)cCodeAssignment_3.eContents().get(0);
		
		//Event:
		//	'event' name=ID 'code' code=ID;
		@Override public ParserRule getRule() { return rule; }
		
		//'event' name=ID 'code' code=ID
		public Group getGroup() { return cGroup; }
		
		//'event'
		public Keyword getEventKeyword_0() { return cEventKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//'code'
		public Keyword getCodeKeyword_2() { return cCodeKeyword_2; }
		
		//code=ID
		public Assignment getCodeAssignment_3() { return cCodeAssignment_3; }
		
		//ID
		public RuleCall getCodeIDTerminalRuleCall_3_0() { return cCodeIDTerminalRuleCall_3_0; }
	}
	public class StateElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.javadude.dsl5.GothicSecurityDsl.State");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cStateKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cActionsAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cActionsActionParserRuleCall_3_0 = (RuleCall)cActionsAssignment_3.eContents().get(0);
		private final Assignment cTransitionsAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cTransitionsTransitionParserRuleCall_4_0 = (RuleCall)cTransitionsAssignment_4.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//State:
		//	'state' name=ID '{'
		//	actions+=Action*
		//	transitions+=Transition*
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'state' name=ID '{' actions+=Action* transitions+=Transition* '}'
		public Group getGroup() { return cGroup; }
		
		//'state'
		public Keyword getStateKeyword_0() { return cStateKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//actions+=Action*
		public Assignment getActionsAssignment_3() { return cActionsAssignment_3; }
		
		//Action
		public RuleCall getActionsActionParserRuleCall_3_0() { return cActionsActionParserRuleCall_3_0; }
		
		//transitions+=Transition*
		public Assignment getTransitionsAssignment_4() { return cTransitionsAssignment_4; }
		
		//Transition
		public RuleCall getTransitionsTransitionParserRuleCall_4_0() { return cTransitionsTransitionParserRuleCall_4_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	public class ActionElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.javadude.dsl5.GothicSecurityDsl.Action");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cActionKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cCommandAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final CrossReference cCommandCommandCrossReference_1_0 = (CrossReference)cCommandAssignment_1.eContents().get(0);
		private final RuleCall cCommandCommandIDTerminalRuleCall_1_0_1 = (RuleCall)cCommandCommandCrossReference_1_0.eContents().get(1);
		
		//Action:
		//	'action' command=[Command];
		@Override public ParserRule getRule() { return rule; }
		
		//'action' command=[Command]
		public Group getGroup() { return cGroup; }
		
		//'action'
		public Keyword getActionKeyword_0() { return cActionKeyword_0; }
		
		//command=[Command]
		public Assignment getCommandAssignment_1() { return cCommandAssignment_1; }
		
		//[Command]
		public CrossReference getCommandCommandCrossReference_1_0() { return cCommandCommandCrossReference_1_0; }
		
		//ID
		public RuleCall getCommandCommandIDTerminalRuleCall_1_0_1() { return cCommandCommandIDTerminalRuleCall_1_0_1; }
	}
	public class TransitionElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.javadude.dsl5.GothicSecurityDsl.Transition");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cOnKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cEventAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final CrossReference cEventEventCrossReference_1_0 = (CrossReference)cEventAssignment_1.eContents().get(0);
		private final RuleCall cEventEventIDTerminalRuleCall_1_0_1 = (RuleCall)cEventEventCrossReference_1_0.eContents().get(1);
		private final Keyword cSwitchKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Keyword cToKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cTargetAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final CrossReference cTargetStateCrossReference_4_0 = (CrossReference)cTargetAssignment_4.eContents().get(0);
		private final RuleCall cTargetStateIDTerminalRuleCall_4_0_1 = (RuleCall)cTargetStateCrossReference_4_0.eContents().get(1);
		
		//Transition:
		//	'on' event=[Event] 'switch' 'to' target=[State];
		@Override public ParserRule getRule() { return rule; }
		
		//'on' event=[Event] 'switch' 'to' target=[State]
		public Group getGroup() { return cGroup; }
		
		//'on'
		public Keyword getOnKeyword_0() { return cOnKeyword_0; }
		
		//event=[Event]
		public Assignment getEventAssignment_1() { return cEventAssignment_1; }
		
		//[Event]
		public CrossReference getEventEventCrossReference_1_0() { return cEventEventCrossReference_1_0; }
		
		//ID
		public RuleCall getEventEventIDTerminalRuleCall_1_0_1() { return cEventEventIDTerminalRuleCall_1_0_1; }
		
		//'switch'
		public Keyword getSwitchKeyword_2() { return cSwitchKeyword_2; }
		
		//'to'
		public Keyword getToKeyword_3() { return cToKeyword_3; }
		
		//target=[State]
		public Assignment getTargetAssignment_4() { return cTargetAssignment_4; }
		
		//[State]
		public CrossReference getTargetStateCrossReference_4_0() { return cTargetStateCrossReference_4_0; }
		
		//ID
		public RuleCall getTargetStateIDTerminalRuleCall_4_0_1() { return cTargetStateIDTerminalRuleCall_4_0_1; }
	}
	public class ResetElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.javadude.dsl5.GothicSecurityDsl.Reset");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cResetKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cOnKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cEventAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final CrossReference cEventEventCrossReference_2_0 = (CrossReference)cEventAssignment_2.eContents().get(0);
		private final RuleCall cEventEventIDTerminalRuleCall_2_0_1 = (RuleCall)cEventEventCrossReference_2_0.eContents().get(1);
		
		//Reset:
		//	'reset' 'on' event=[Event];
		@Override public ParserRule getRule() { return rule; }
		
		//'reset' 'on' event=[Event]
		public Group getGroup() { return cGroup; }
		
		//'reset'
		public Keyword getResetKeyword_0() { return cResetKeyword_0; }
		
		//'on'
		public Keyword getOnKeyword_1() { return cOnKeyword_1; }
		
		//event=[Event]
		public Assignment getEventAssignment_2() { return cEventAssignment_2; }
		
		//[Event]
		public CrossReference getEventEventCrossReference_2_0() { return cEventEventCrossReference_2_0; }
		
		//ID
		public RuleCall getEventEventIDTerminalRuleCall_2_0_1() { return cEventEventIDTerminalRuleCall_2_0_1; }
	}
	public class TestElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.javadude.dsl5.GothicSecurityDsl.Test");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cTestKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cEventsAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final CrossReference cEventsEventCrossReference_3_0 = (CrossReference)cEventsAssignment_3.eContents().get(0);
		private final RuleCall cEventsEventIDTerminalRuleCall_3_0_1 = (RuleCall)cEventsEventCrossReference_3_0.eContents().get(1);
		private final Keyword cRightCurlyBracketKeyword_4 = (Keyword)cGroup.eContents().get(4);
		
		//Test:
		//	'test' name=ID '{'
		//	events+=[Event]+
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'test' name=ID '{' events+=[Event]+ '}'
		public Group getGroup() { return cGroup; }
		
		//'test'
		public Keyword getTestKeyword_0() { return cTestKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//events+=[Event]+
		public Assignment getEventsAssignment_3() { return cEventsAssignment_3; }
		
		//[Event]
		public CrossReference getEventsEventCrossReference_3_0() { return cEventsEventCrossReference_3_0; }
		
		//ID
		public RuleCall getEventsEventIDTerminalRuleCall_3_0_1() { return cEventsEventIDTerminalRuleCall_3_0_1; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_4() { return cRightCurlyBracketKeyword_4; }
	}
	
	
	private final StateMachineElements pStateMachine;
	private final CommandElements pCommand;
	private final EventElements pEvent;
	private final StateElements pState;
	private final ActionElements pAction;
	private final TransitionElements pTransition;
	private final ResetElements pReset;
	private final TestElements pTest;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public GothicSecurityDslGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pStateMachine = new StateMachineElements();
		this.pCommand = new CommandElements();
		this.pEvent = new EventElements();
		this.pState = new StateElements();
		this.pAction = new ActionElements();
		this.pTransition = new TransitionElements();
		this.pReset = new ResetElements();
		this.pTest = new TestElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("com.javadude.dsl5.GothicSecurityDsl".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//StateMachine:
	//	'stateMachine' name=ID '{'
	//	'start' startState=[State] commands+=Command*
	//	events+=Event*
	//	states+=State*
	//	resetEvents+=Reset*
	//	tests+=Test*
	//	'}';
	public StateMachineElements getStateMachineAccess() {
		return pStateMachine;
	}
	
	public ParserRule getStateMachineRule() {
		return getStateMachineAccess().getRule();
	}
	
	//Command:
	//	'command' name=ID 'code' code=ID;
	public CommandElements getCommandAccess() {
		return pCommand;
	}
	
	public ParserRule getCommandRule() {
		return getCommandAccess().getRule();
	}
	
	//Event:
	//	'event' name=ID 'code' code=ID;
	public EventElements getEventAccess() {
		return pEvent;
	}
	
	public ParserRule getEventRule() {
		return getEventAccess().getRule();
	}
	
	//State:
	//	'state' name=ID '{'
	//	actions+=Action*
	//	transitions+=Transition*
	//	'}';
	public StateElements getStateAccess() {
		return pState;
	}
	
	public ParserRule getStateRule() {
		return getStateAccess().getRule();
	}
	
	//Action:
	//	'action' command=[Command];
	public ActionElements getActionAccess() {
		return pAction;
	}
	
	public ParserRule getActionRule() {
		return getActionAccess().getRule();
	}
	
	//Transition:
	//	'on' event=[Event] 'switch' 'to' target=[State];
	public TransitionElements getTransitionAccess() {
		return pTransition;
	}
	
	public ParserRule getTransitionRule() {
		return getTransitionAccess().getRule();
	}
	
	//Reset:
	//	'reset' 'on' event=[Event];
	public ResetElements getResetAccess() {
		return pReset;
	}
	
	public ParserRule getResetRule() {
		return getResetAccess().getRule();
	}
	
	//Test:
	//	'test' name=ID '{'
	//	events+=[Event]+
	//	'}';
	public TestElements getTestAccess() {
		return pTest;
	}
	
	public ParserRule getTestRule() {
		return getTestAccess().getRule();
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' | "'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
